<?php

$bucket = get_option('AWS_BUCKET');
$key = get_option('AWS_KEY');
$secret_key = get_option('AWS_SECRET_KEY');


list($testConnection, $sirv_authMessage)  = sirv_test_connection($bucket, $key, $secret_key);


if (get_option('WP_USE_SIRV_CDN') != 1) { ?>
  <script>
    jQuery(function($){
      $(document).ready(function(){
        window['networkStatus'] = false;
      });
    });
  </script>
<?php } ?>

<script>
    jQuery(function($){
        $(document).ready(function(){

          //move overlay to hide all content in window instead of wrap div only
          $('.sirv-s3-info-overlay').prependTo('body');

          //add scrollable menu for help tab
          $(window).bind('scroll', function () {
              if ($(window).scrollTop() > 170 && $(window).width() > 767) {
                  $('.sirv-help-menu').addClass('sirv-help-menu-fixed');
                  $('.sirv-help-data').addClass('sirv-help-data-margin');
              } else {
                  $('.sirv-help-menu').removeClass('sirv-help-menu-fixed');
                  $('.sirv-help-data').removeClass('sirv-help-data-margin');
              }
          });

          $('.nav-tab-sirv-help').on('click', function(){
            setTimeout(function(){
              //$('.nav').scrollSpy({activeClass: 'scrollNav-active', offset: 100});
              $('.sirv-help-menu').scrollSpy();
            }, 300);
          });

          // Add smooth scrolling on all links inside the navbar
          $(".sirv-help-menu a").on('click', function(event) {
            // Make sure this.hash has a value before overriding default behavior
            if (this.hash !== "") {
              // Prevent default anchor click behavior
              event.preventDefault();

              // Store hash
              var hash = this.hash;

              // Using jQuery's animate() method to add smooth page scroll
              // The optional number (800) specifies the number of milliseconds it takes to scroll to the specified area
              $('html, body').animate({
                scrollTop: $(hash).offset().top
              }, 800, function(){

                // Add hash (#) to URL when done scrolling (default click behavior)
                window.location.hash = hash;
              });
            }  // End if
          });

            //------------globals vars--------------------
            let sync_progress_bar_text = 'Synchronization progress: ';
            //FirstImageUploadDelay - delay before first image will be uploaded. Need if loading big image and getUploadingStatus() will not get status info during uploading first image
            let FirstImageUploadDelay = 100;
            //check if need update sync status
            let syncStatusFlag = false;
            //var for check if image is changing or php stopped.
            let prevProccImage = null;
            let isScriptStoppedDelay = 15;
            //-------------------------------------------

            //if hash #sirv-stats than activate stats tab and run requests
            if(location.href.split("#")[1] == 'sirv-stats'){
              $('.nav-tab-active').removeClass('nav-tab-active');
              $('#sirv-stats').addClass('nav-tab-active');
              $object = $('.nav-tab-sirv-stats');
              changeTab(undefined, $object);
              getStorageData();
              getTrafficData();
            }else if(location.href.split("#")[1] == 'help-feedback'){
              $('.nav-tab-active').removeClass('nav-tab-active');
              $('#help-feedback').addClass('nav-tab-active');
              $object = $('.nav-tab-sirv-feedback');
              changeTab(undefined, $object);
            }


            //tabs logic
            /*$('.nav-tab-wrapper > a').on('click', function(e){
                $('.sirv-tab-content').removeClass('sirv-tab-content-active');
                $('.nav-tab-wrapper > a').removeClass('nav-tab-active');
                $('.sirv-tab-content'+$(this).attr('href')).addClass('sirv-tab-content-active');
                $(this).addClass('nav-tab-active').blur();
                $('#active_tab').val($(this).attr('href'));
                e.preventDefault();
            });*/

            $('.nav-tab-wrapper > a').on('click', function(e){changeTab(e, $(this));});
            $('.sirv-show-account-tab').on('click', function(e){changeTab(e, $('.nav-tab-sirv-account'));});

            function changeTab(e, $object){
                $('.sirv-tab-content').removeClass('sirv-tab-content-active');
                $('.nav-tab-wrapper > a').removeClass('nav-tab-active');
                $('.sirv-tab-content' + $object.attr('href')).addClass('sirv-tab-content-active');
                $object.addClass('nav-tab-active').blur();
                $('#active_tab').val($object.attr('href'));
                if(typeof e !== 'undefined') e.preventDefault();
            }


            ////test that login details is correct
            $('.test-connect').on('click', function(){
                let host = 's3.sirv.com',
                    bucket = $('input[name=AWS_BUCKET]').val(),
                    key = $('input[name=AWS_KEY]').val(),
                    secret_key = $('input[name=AWS_SECRET_KEY]').val();

                $('.show-result').html("Testing connection...").show();

                $.post(ajaxurl, {
                action: 'sirv_check_connection',
                host: host,
                bucket: bucket,
                key: key,
                secret_key: secret_key
                }).done(function(data){
                    //debug
                    //console.log(data);
                    $('.show-result').html(data);

                }).fail(function(){
                    $('.show-result').html("Failed ajax request to check sirv login details!");
                });
            })


            //ajax request to get cached count and size of images
            $('.nav-tab-sirv-cache').on('click', getSyncProgress);

            function getCachedData(){

              //remove event after cache tab select
              $('.nav-tab-sirv-cache').unbind('click', getCachedData);

              $.post(ajaxurl,{
                  action: 'sirv_get_cached_data',
                  get_cached_data: true,
                  beforeSend: function(){
                    $('input[name=invalidate-cache]').prop('disabled', true);
                    $('input[name=purge-cache]').prop('disabled', true);
                    $('input[name=sirv-sync-images]').prop('disabled', true);
                  }
              }).done(function(data){
                      //debug
                      //console.log(data);

                      let json_obj = $.parseJSON(data);
                      let all_post_images = '';
                      if(typeof networkStatus !== "undefined" && networkStatus == false){
                        $('input[name=invalidate-cache]').prop('disabled', true);
                        $('input[name=purge-cache]').prop('disabled', true);
                        if(parseInt(json_obj.uncached_count) == 0){
                          manageElement('input[name=sirv-sync-images]', disableFlag=true, text='100% synced', button=true);
                        }else{
                          manageElement('input[name=sirv-sync-images]', disableFlag=true);
                        }
                      }else{
                        //disable clean cache button if empty cache
                        if(json_obj.count == '0'){
                          $('input[name=invalidate-cache]').prop('disabled', true);
                          $('input[name=purge-cache]').prop('disabled', true);
                        }else{
                          $('input[name=invalidate-cache]').prop('disabled', false);
                          $('input[name=purge-cache]').prop('disabled', false);
                        }

                        all_post_images = ' of ' + json_obj.all_post_images;
                        if(parseInt(json_obj.uncached_count) !== 0 && parseInt(json_obj.count) !== parseInt(json_obj.all_post_images)){
                          manageElement('input[name=sirv-sync-images]', disableFlag=false, text='Sync images', button=true);
                        }else{
                          manageElement('input[name=sirv-sync-images]', disableFlag=true, text='100% synced', button=true);

                        }
                      }

                      //sum_size = json_obj.sum_size/1000000;
                      $('.cache-img-num').html(json_obj.count + all_post_images);
                      //$('.cache-size').html( sum_size.toFixed(2) +' MB');
                      $('.cache-size').html(getFormatedFileSize(json_obj.sum_size));

                      $('.sirv-sync-images-progress-text').html( (json_obj.all_post_images==0)? sync_progress_bar_text + '0%': sync_progress_bar_text + parseInt(json_obj.count/json_obj.all_post_images*100)+'%' )
                      $('.sirv-sync-images-progress-bar').css('width', (json_obj.all_post_images==0)?'0%': parseInt(json_obj.count/json_obj.all_post_images*100)+'%' )

                  }).fail(function(){
                      console.log("Failed ajax request to get cached image data!");
              });
            }


            //bind manageCache func to buttons
            $('.invalidate-cache').bind('click', manageCache);
            $('.purge-cache').bind('click', manageCache);

            //ajax request to clean up cache
            function manageCache(){

              let cleanType = $(this).hasClass('invalidate-cache') == true ? 'quick' : 'full';

              $.post(ajaxurl,{
                    action: 'sirv_clear_cache',
                    clean_cache_type: cleanType,
                    beforeSend: function(){
                      if(cleanType == 'quick'){
                        $('.invalidate-cache-result').html('Processing...');
                      }else{
                        $('.purge-cache-result').html('Processing...');
                      }
                    }
                }).done(function(data){
                    //debug
                    //console.log(data);
                    $('.cache-img-num').html('0');
                    $('.cache-size').html( '0.00 MB');

                    if(cleanType == 'quick'){
                      $('input[name=invalidate-cache]').prop('disabled', true);
                      $('.invalidate-cache-result').html('Successfuly cleared');
                    }else{
                      $('input[name=invalidate-cache]').prop('disabled', true);
                      $('input[name=purge-cache]').prop('disabled', true);
                      $('.purge-cache-result').html('Successfuly deleted images on Sirv');
                    }

                    //$('.sirv-sync-images-progress-block').show();
                    $('.sirv-sync-images-progress-text').html('0%');
                    $('.sirv-sync-images-progress-bar').css('width','0%');
                    //$('input[name=sirv-sync-images]').prop('disabled', false);
                    manageElement('input[name=sirv-sync-images]', disableFlag=false, text='Sync images', button=true);

                }).fail(function(jqXHR, status, error){
                    if(cleanType == 'quick'){
                      $('.invalidate-cache-result').html('Ajax error: ' + error);
                    }else{
                      $('.purge-cache-result').html('Ajax error: ' + error);
                    }

                });
            }


            //send the message from plugin to support@sirv.com
            $('#send-email-to-magictoolbox').on('click', function(){
              //fields
              let name = $('#sirv-writer-name').val();
              let contactEmail = $('#sirv-writer-contact-email').val();
              //let priority = $('#sirv-priority').val();
              let summary = $('#sirv-summary').val();
              let messageText = $('#sirv-text').val();

              //messages;
              let proccessingSendMessage = '<span class="sirv-traffic-loading-ico sirv-no-lmargin"></span> Sending message. This may take some time...';
              let messageSent = 'Your message has been sent.';
              let ajaxError = 'Error during AJAX request. Please try to send the message again or use the <a target="_blank" href="https://sirv.com/contact/">Sirv contact form here</a> Error: <br/>';
              let sendingError = 'Something went wrong. The most likely reason is that Sendmail is not installed/configured. Please try to send the message again or use the <a target="_blank" href="https://sirv.com/contact/">Sirv contact form here</a>';
              //form messages
              let emptyFields = '<span style="color: red;">Please fill form fields.</span>';
              let incorrectEmail = '<span style="color: red;">Email is incorrect. Please check email field.</span>';

              let generatedViaWP = '\n\n\n---\nThis message was sent from the Sirv WordPress plugin form at ' + document.location.hostname;


              let formMessages = '';

              if(summary == '' || messageText == '' || name == '' || contactEmail == ''){
                formMessages += emptyFields + '<br />';
              }

              if(contactEmail.match(/[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,3}$/i) == null && contactEmail != ''){
                formMessages += incorrectEmail + '<br />';
              }

              if(formMessages != ''){
                $('.sirv-show-result').html(formMessages);
                return false;
              }

              $.post(ajaxurl,{
                action: 'sirv_send_message',
                name: name,
                emailFrom: contactEmail,
                //priority: priority + ' (via WP)',
                summary: summary,
                text: 'Contact name: ' + name +'\n' + 'Contact Email: ' + contactEmail +'\n\n' + messageText + generatedViaWP,
                beforeSend: function(){
                    $('.sirv-show-result').html(proccessingSendMessage);
                }
              }).done(function(data){
                    //debug
                    //console.log(data);

                    if(data == '1'){
                      $('.sirv-show-result').html(messageSent);
                    }else{
                      $('.sirv-show-result').html(sendingError);
                    }

                    //clear contact form fields
                    $('#sirv-writer-name').val('');
                    $('#sirv-writer-contact-email').val('');
                    $('#sirv-summary').val('');
                    $('#sirv-text').val('');

                }).fail(function(jqXHR, status, error){
                    console.log("Error during ajax request: " + error);
                    $('.sirv-show-result').html(ajaxError + error);
                });

            });


          //sanitize custom domain and folder on sirv
          $('#sirv-save-options').submit(function(){
            let customDomain = $("[name='WP_SIRV_CUSTOM_DOMAIN']").val();
            let folderOnSirv = $("[name='WP_FOLDER_ON_SIRV']").val();
            let sanitizedCustomDomain = customDomain.replace(/(https?:\/\/)?(www\.)?([-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6})\/*/ig, '$3');
            let sanitizedFolderOnSirv = folderOnSirv == '' ? 'WP_SirvMediaLibrary' : folderOnSirv.replace(/^[\/]*(.*?)[\/]*$/ig, '$1');
            $("[name='WP_SIRV_CUSTOM_DOMAIN']").val(sanitizedCustomDomain);
            $("[name='WP_FOLDER_ON_SIRV']").val(sanitizedFolderOnSirv);

            return true;
          });


        //ajax request to sync images
        let timer;
        $('.sirv-sync-images').on('click', function(){
          $('.sync-errors').empty();
          $.post(ajaxurl,{
              action: 'sirv_sync_uncached_images',
              sirv_sync_uncached_images: true,
              async: true,
              beforeSend: function(){
                if(!syncStatusFlag){
                  timer = window.setInterval(getSyncProgress, 2500);
                  syncStatusFlag = true;
                }
                $('input[name=invalidate-cache]').prop('disabled', true);
                $('input[name=purge-cache]').prop('disabled', true);
                manageElement('input[name=sirv-sync-images]', disableFlag=true, text='Syncing', button=true);
                $('.invalidate-cache-result').html('');
                $('.purge-cache-result').html('');
                //$('.cache-size').html('pending...');
                $('.cache-size').html('<span class="sirv-traffic-loading-ico sirv-no-lmargin"></span> pending...');
                $('.sirv-sync-images-progress-bar').addClass('sirv-progress-bar-animated');
                $('.sync-errors').hide();
              }
          }).done(function(data){
                  //debug
                  console.log(data);

                  if(data !== '' && isJsonString(data)){
                    let json_obj = JSON.parse(data);

                    if(json_obj.error_images.length > 0){
                      let error_images_console = '';
                      let error_images = '';

                      for(let i =0; i<json_obj.error_images.length; i++){
                        error_images_console += json_obj.error_images[i].image_url + '\n';
                        error_images += '<a href="' +json_obj.error_images[i].image_url + '" target="_blank">'+ json_obj.error_images[i].image_url +'</a><br>';
                      }

                      let $errorListDiv = $('<div class="sirv-error-list-images-wrap"><div class="sirv-error-list-images-title sirv-no-select-text"><span>Show/hide list of images</span></div><div class="sirv-error-list-images">'+ error_images +'</div></div>');

                      console.error(json_obj.message);
                      console.error(error_images);
                      showErrorMessage($('.sync-errors'), json_obj.message + ' <span class="sirv-show-hide-list .sirv-no-select-text">Show list</span>');
                      showErrorMessage($('.sync-errors'), $errorListDiv.prop('outerHTML'), false);
                      $('.sirv-show-hide-list').bind('click', toogleList);
                    }
                  }

                  $('input[name=invalidate-cache]').prop('disabled', false);
                  $('input[name=purge-cache]').prop('disabled', false);
                  $('.sirv-sync-images-progress-bar').removeClass('sirv-progress-bar-animated');

              }).fail(function(jqXHR, status, error){
                    $('.sirv-sync-images-progress-bar').removeClass('sirv-progress-bar-animated');
                    console.log("Error during ajax request: " + error);
                    showErrorMessage($('.sync-errors'), "Ajax error " + error + '. Sync status cannot be displayed. Either wait or refresh this page.');
                    window.clearInterval(timer);
          });
        });


        function isJsonString(str) {
          try {
                JSON.parse(str);
            } catch (e) {
                return false;
            }
            return true;
        }


        function toogleList(){
          if($('.sirv-error-list-images-wrap').is(":visible")){
            $('.sirv-error-list-images-wrap').hide();
          }else{
            $('.sirv-error-list-images-wrap').show();
          }
        }


        function showErrorMessage($selector, message, isIndent=true){
          let indent = isIndent ? '<br />' : '';
          let hr = isIndent ? '<hr>' : '';
          $selector.append(hr + message + indent);
          $selector.show();
        }


        function getSyncProgress(){
            //remove event after cache tab select
            $('.nav-tab-sirv-cache').unbind('click', getSyncProgress);

            let data = {};
            data['action'] = 'sirv_get_sync_status';
            data['sirv_get_sync_status'] = true;

            $.ajax({
                url: ajaxurl,
                data: data,
                type: 'POST'
            }).done(function(response){
                    //debug
                    //console.log(response);

                    let json_obj = JSON.parse(response);

                    if(json_obj.stopSyncStatus == false && !syncStatusFlag){
                      timer = window.setInterval(getSyncProgress, 2500);
                      syncStatusFlag = true;

                      $('input[name=invalidate-cache]').prop('disabled', true);
                      $('input[name=purge-cache]').prop('disabled', true);
                      manageElement('input[name=sirv-sync-images]', disableFlag=true, text='Syncing', button=true);
                      $('.invalidate-cache-result').html('');
                      $('.purge-cache-result').html('');
                      $('.cache-size').html('<span class="sirv-traffic-loading-ico sirv-no-lmargin"></span> pending...');
                      $('.sirv-sync-images-progress-bar').addClass('sirv-progress-bar-animated');

                    }

                    if(json_obj.processedImage!== null || json_obj.count !== null){
                      if(json_obj.processedImage === prevProccImage){
                        if(isScriptStoppedDelay === 0){
                          window.clearInterval(timer);
                          syncStatusFlag = false;
                          $('.sirv-sync-images-progress-bar').removeClass('sirv-progress-bar-animated');
                          $('input[name=sirv-sync-images]').prop('disabled', true);
                          clearSession();
                          getCachedData();
                          showErrorMessage($('.sync-errors'), 'Synchronization stopped. Restart the sync and stay on this page until it reaches 100%.');
                          return false;
                        }
                        isScriptStoppedDelay --;

                      }else{
                        prevProccImage = json_obj.processedImage;
                        isScriptStoppedDelay = 15;
                      }

                      if (json_obj.percent == 100 || json_obj.stopSyncStatus == true || json_obj.stopSyncStatus == null) {
                        window.clearInterval(timer);
                        syncStatusFlag = false;
                        $('.sirv-sync-images-progress-bar').removeClass('sirv-progress-bar-animated');
                        $('input[name=sirv-sync-images]').prop('disabled', true);
                        getCachedData();
                      }else{
                        $('.sirv-sync-images-progress-bar').css('width', json_obj.percent + '%');
                        $('.sirv-sync-images-progress-text').html(sync_progress_bar_text + json_obj.percent + '%');
                        $('.cache-img-num').html(json_obj.processedImage + ' of '+ json_obj.count);
                      }

                    }else{
                      $('.sirv-progress-text').html('processing...');
                      if(FirstImageUploadDelay == 0){
                        window.clearInterval(timer);
                        FirstImageUploadDelay = 100;
                      }
                      FirstImageUploadDelay--;
                    }
            }).fail(function(jqXHR, status, error){
                    console.log("Error during ajax request: " + error);
                    window.clearInterval(timer);
                    getCachedData();
            });
        }


        function clearSession(){
          let data = {};
            data['action'] = 'sirv_clear_upload_session';
            data['sirv_clear_upload_session'] = true;

            $.ajax({
                url: ajaxurl,
                data: data,
                type: 'POST'
            }).done(function(response){
              //console.log('Sirv: session cleared.');
            }).fail(function(jqXHR, status, error){
                    console.log("Error during ajax request: " + error);
            });
        }


        //clean 30 rows in table. need for tests.
        $('.test-clean-30-rows').on('click', function(){
          let data = {};
          data['action'] = 'sirv_delete_thirty_rows';
          data['sirv_delete_thirty_rows'] = true;

          $.ajax({
              url: ajaxurl,
              data: data,
              type: 'POST'
          }).done(function(response){
                  //debug
                  //console.log(response);
                  getCachedData();

          }).fail(function(jqXHR, status, error){
                  console.log("Error during ajax request: " + error);
          });
        });


        $('.nav-tab-sirv-stats').on('click', getStorageData);
        function getStorageData(){

          $('.nav-tab-sirv-stats').unbind('click', getStorageData);

          let data = {};
          data['action'] = 'sirv_get_storage_data';
          data['sirv_get_storage_data'] = true;

          $.ajax({
              url: ajaxurl,
              data: data,
              type: 'POST'
          }).done(function(response){
                  //debug
                  //console.log(response);

                  if(response !== '' && isJsonString(response)){
                    let json_obj = JSON.parse(response);

                    $('.sirv-st-total').html(getFormatedFileSize(json_obj.plan + json_obj.extra));
                    $('.sirv-st-used').html(getFormatedFileSize(json_obj.used) + ' <span>(' + ((json_obj.used/(json_obj.plan + json_obj.extra))*100).toFixed(1) +'%)</span>');
                    let available = (json_obj.plan + json_obj.extra) - json_obj.used;
                    if(available < 0){
                      $('.sirv-st-available').html('<span style="color: red;">' + getFormatedFileSize(available) + ' (' + ((available/(json_obj.plan + json_obj.extra))*100).toFixed(1) +'%) <a target="_blank" href="https://my.sirv.com/#/account/billing/plan">Please upgrade</a></span>');
                    }else{
                      $('.sirv-st-available').html(getFormatedFileSize(available) + ' <span>(' + ((available/(json_obj.plan + json_obj.extra))*100).toFixed(1) +'%)</span>');
                    }
                    $('.sirv-st-files').html(new Intl.NumberFormat().format(json_obj.files));
                  }else{
                    $('.sirv-st-total').html('Fetch data failed');
                    $('.sirv-st-used').html('Fetch data failed');
                    $('.sirv-st-available').html('Fetch data failed');
                    $('.sirv-st-files').html('Fetch data failed');

                    console.error('Server returned non JSON Storage data');
                    console.info('Response dump:', response);
                  }

          }).fail(function(jqXHR, status, error){
                  console.log("Error during ajax request: " + error);

                  $('.sirv-st-total').html('Fetch data failed');
                  $('.sirv-st-used').html('Fetch data failed');
                  $('.sirv-st-available').html('Fetch data failed');
                  $('.sirv-st-files').html('Fetch data failed');
          });
        }


        function getAccountInfo(accountPlanData){
          let data = {};
          data['action'] = 'sirv_get_account_info';
          data['sirv_get_account_info'] = true;

          $.ajax({
              url: ajaxurl,
              data: data,
              type: 'POST'
          }).done(function(response){
                  //debug
                  //console.log(response);

                  if(response !== '' && isJsonString(response)){
                    let json_obj = JSON.parse(response);

                    $.extend(accountPlanData, json_obj);

                    let storage = getFormatedFileSize(json_obj.plan.storage);
                    let dataTransferLimit = getFormatedFileSize(json_obj.plan.dataTransferLimit);

                    $('.sirv-tf-allowance').html(dataTransferLimit);
                    $('.sirv-account-plan').html(json_obj.plan.name +' ('+ storage +' storage, '+ dataTransferLimit + ' monthly transfer) <a target="_blank" href="https://my.sirv.com/#/account/billing/plan">Upgrade plan</a>');
                  }else{
                    console.error('Server returned non JSON Account data');
                    console.info('Response dump:', response);

                    $('.sirv-tf-allowance').html('Fetch data failed');
                    $('.sirv-account-plan').html('Fetch data failed');
                  }


          }).fail(function(jqXHR, status, error){
                  console.log("Error during ajax request: " + error);

                  $('.sirv-tf-allowance').html('Fetch data failed');
                  $('.sirv-account-plan').html('Fetch data failed');
          });
        }


        $('.nav-tab-sirv-stats').on('click', getTrafficData);
        function getTrafficData(){

          $('.nav-tab-sirv-stats').unbind('click', getTrafficData);

          let dates = {
                        thisMonth:      calcDate('none', true),
                        previousMonth1: calcDate(1),
                        previousMonth2: calcDate(2),
                        previousMonth3: calcDate(3),
                      }

          let data = {};
          let trafficData = [];
          let accountPlanData = {};
          data['action'] = 'sirv_get_traffic_data';
          data['traffic_range'] = dates.thisMonth;

          $.each(dates, function(key, value){

            data['traffic_range'] = value;
            ajaxRequest(ajaxurl, data, 'POST', true, trafficData, key, value);

          });

          getAccountInfo(accountPlanData);

          //wait till ajax all requests will be done
          let checkLoadingStatusTimer = window.setInterval(checkLoadingStatus, 200);
          function checkLoadingStatus(){
            if(trafficData.length == 4 && !$.isEmptyObject(accountPlanData)){
              window.clearInterval(checkLoadingStatusTimer);
              renderTrafficData(trafficData, accountPlanData);
            }else if(trafficData.length == 13){
              window.clearInterval(checkLoadingStatusTimer);
              $('.sirv-tf-loading-error').show();

            }
          }
        }


        function ajaxRequest(ajaxurl, data, type='POST', async=true, trafficData, key, value){
          $.ajax({
              url: ajaxurl,
              data: data,
              type: type,
              async: async
            }).done(function(response){
                    //console.log(response);

                    if(response !== '' && isJsonString(response)){
                      let json_obj = JSON.parse(response);
                      trafficData.push({size: calcTraffic(json_obj), date: value[2], order: value[3]});
                    }else{
                      console.error('Server returned non JSON Trafic data');
                      console.info('Response dump:', response);
                      trafficData.length = 13;
                      $('.sirv-tf-loading-error').html("Error during ajax request: Fetch data failed");
                      $('.sirv-traffic-loading').hide();
                    }

            }).fail(function(jqXHR, status, error){
                    console.log("Error during ajax request: " + error + status);
                    //hack to check that data is not fetched
                    trafficData.length = 13;
                    if(error){
                      $('.sirv-tf-loading-error').html("Error during ajax request: " + error);
                    }else{
                      $('.sirv-tf-loading-error').html("Error during ajax request: Fetch data failed");
                    }
                    $('.sirv-traffic-loading').hide();
            });
        }


        function renderTrafficData(trafficData, accountPlanData){
          let documentFragment = $(document.createDocumentFragment());

          trafficData.sort(function(a,b) {
              return a.order - b.order;
          });

          $('.traffic-wrapper').empty();

          let classColorRed = trafficData[0].size > accountPlanData.plan.dataTransferLimit ? 'color: red;' : '';
          $('.traffic-wrapper').append('<tr class="small-padding"><th><label>Allowance</label></th><td colspan="2"><span style="'+ classColorRed +'" class="sirv-trf-month">'+ getFormatedFileSize(accountPlanData.plan.dataTransferLimit) +'/month</span></td></tr>');

          for(let i=0; i<trafficData.length; i++){
            let trafficPercent = (trafficData[i].size / accountPlanData.plan.dataTransferLimit * 100).toFixed(0);

            //small hack if percent = 0 but some traffic was used, than will show const 1%
            trafficPercent = (trafficPercent == 0 && trafficData[i].size > 0) ? 1 : trafficPercent > 100 ? 100 : trafficPercent;
            let classBgColorRed =  trafficPercent == 100 ? 'background-color: #efb3b3; ' : '';
            let elemBlock = $('<tr class="small-padding"><th><label>'+ trafficData[i].date +'</label></th><td><span class="sirv-trf-month-'+ i +'">'+ getFormatedFileSize(trafficData[i].size) +'</span></td><td><div class="graph-bar-wrapper"><span class="graph-bar" style="width: '+ trafficPercent +'%; '+ classBgColorRed +'"></span></div></td></tr>');
            documentFragment.append(elemBlock);
          }
          $('.tf-show-block').remove();
          $('.traffic-wrapper').append(documentFragment);
          $('.sirv-traffic-loading').hide();

        }


        function calcTraffic(trafficData){
          let sum = 0;
          $.each(trafficData, function(key, value){
            //console.log('key => ' + new Date(parseInt(key)) + '; value => ' + value.total.size);
            sum += parseInt(value.total.size);
          });

          return sum;
        }


        function calcDate(monthDiff, thisMonth=false){
          let monthNames = [
                            "January",
                            "February",
                            "March",
                            "April",
                            "May",
                            "June",
                            "July",
                            "August",
                            "September",
                            "October",
                            "November",
                            "December"
                          ];
          let ctDate = new Date();
          let ctMonth = ctDate.getMonth();
          let ctYear = ctDate.getFullYear();
          let ctTimeZoneOffset = Math.abs(ctDate.getTimezoneOffset())/60;

          let tmp_arr = [];

          if(typeof thisMonth !== undefined && thisMonth == true){
            tmp_arr.push((new Date(ctYear, ctMonth, 1, ctTimeZoneOffset)).toISOString());
            tmp_arr.push(ctDate.toISOString());
            tmp_arr.push('This month');
            tmp_arr.push(0);//element order
          }

          if(typeof monthDiff !== undefined && monthDiff !=='none'){
            let fromDate = new Date(ctYear, ctMonth - monthDiff, 1, ctTimeZoneOffset);
            let toDate = new Date(ctYear, ctMonth - monthDiff + 1, 0, ctTimeZoneOffset);
            let monthData = monthNames[fromDate.getMonth()] + ' ' + fromDate.getFullYear();
            tmp_arr.push(fromDate.toISOString());
            tmp_arr.push(toDate.toISOString());
            tmp_arr.push(monthData);
            tmp_arr.push(monthDiff); //element order
          }

          return tmp_arr;
        }


        function getFormatedFileSize(bytes){
          let negativeFlag = false;
          let position = 0;
          let units = [" Bytes", " KB", " MB", " GB", " TB"];

          bytes = parseInt(bytes);

          if(bytes < 0){
            bytes = Math.abs(bytes);
            negativeFlag = true;
          }

          while (bytes >= 1000 && (bytes / 1000) >= 1) {
            bytes /= 1000;
            position++;
          }

          if(negativeFlag) bytes *= -1;

          bytes = bytes % 1 == 0 ? bytes : bytes.toFixed(2);

          return bytes + units[position];

        }


        function manageElement(selector, disableFlag, text, button, css, html){
          if(disableFlag !== 'none'){
            $(selector).prop('disabled', disableFlag);
          }
          if(typeof text !== 'undefined' && text !== 'none'){
            if(typeof button !== 'undefined' && button !=='none'){
              $(selector).val(text);
            }else{
              $(selector).html(text);
            }

          }
          if(typeof css !== 'undefined' && css !== 'none'){
           $(selector).css(css);
          }
          if(typeof html !== 'undefined' && html !== 'none'){
            $(selector).html(html);
          }
        }


        function getProfiles(){
            let data = {}
            data['action'] = 'sirv_get_profiles';

            $.ajax({
                url: ajaxurl,
                type: 'POST',
                data: data,
                beforeSend: function(){

                }
            }).done(function(response){
                $('span.sirv-shortcodes-profiles, span.sirv-cdn-profiles').hide();
                $('#sirv-shortcodes-profiles, #sirv-cdn-profiles').empty();
                $('#sirv-shortcodes-profiles, #sirv-cdn-profiles').append($(response));

                manageSelect('#sirv-shortcodes-profiles', '#sirv-shortcodes-profiles-val', false);
                manageSelect('#sirv-cdn-profiles', '#sirv-cdn-profiles-val', false);

                $('#sirv-shortcodes-profiles, #sirv-cdn-profiles').addClass('sirv-width-max');

            }).fail(function(jqXHR, status, error){
                $('span.sirv-shortcodes-profiles, span.sirv-cdn-profiles').hide();
                $('#sirv-shortcodes-profiles, #sirv-cdn-profiles').empty();
                $('#sirv-shortcodes-profiles, #sirv-cdn-profiles').html('<option>Fetch data failed</option>');
                console.log("Error during ajax request: " + error + status);
            });
        }


        $('#sirv-shortcodes-profiles').on('change', function(){manageSelect('#sirv-shortcodes-profiles', '#sirv-shortcodes-profiles-val', true);});
        $('#sirv-cdn-profiles').on('change', function(){manageSelect('#sirv-cdn-profiles', '#sirv-cdn-profiles-val', true);});

        function manageSelect(selector, valueElem, onChange=false){
          let $valElem = $(valueElem);

          if(onChange){
            $valElem.val($(selector + ' option:selected').val());
          }else{
            $(selector + " option[value='" + $valElem.val() + "']").attr('selected','selected');
          }

        }



        $('.debug-button').on('click', function(){
            let data = {}
            data['action'] = 'sirv_debug';

            $.ajax({
                url: ajaxurl,
                type: 'POST',
                data: data,
                beforeSend: function(){
                    console.log('-----------------------------------DEBUG START-----------------------------------')
                }
            }).done(function(response){
                console.log(response);
                console.log('-----------------------------------DEBUG END-----------------------------------')
            }).fail(function(jqXHR, status, error){
                console.log("Error during ajax request: " + error + ' ' + status);
                console.log('-----------------------------------DEBUG END-----------------------------------')
            });
        });

        //radiobutton change
        $('input[type=radio][name=WP_SIRV_NETWORK]').change(function(){
          if(this.value == 3){
            $('.custom-domain').show();
          }else{
            $('.custom-domain').hide();
          }
        });


        $('input[type=radio][name=WP_USE_SIRV_CDN]').change(function(){
          if(this.value == 1){
            $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("disabled", false);
          }else{
            $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("disabled", true);
            $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("checked", false);
          }
        });


        function checkNetworkRadioButton(){
            if($('input[type=radio][name=WP_SIRV_NETWORK]:checked').val() == 3){
              $('.custom-domain').show();
            }
        }


        function responsiveCheckboxLogic(){
          if($('input[type=radio][name=WP_USE_SIRV_CDN]:checked').val() == 1){
              $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("disabled", false);
            }else{
              $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("disabled", true);
              $('input[type=checkbox][name=WP_USE_SIRV_RESPONSIVE]').attr("checked", false);
            }
        }


        //key events
        $(window).keyup(function(event) {
          if(event.which == 27){
            if(!$('.sirv-s3-info-overlay').is(':hidden')){
              $('.sirv-s3-info-overlay').hide();
            }
          }
        });

        $('.sirv-s3-info-icon').on('click', function(){
          $('.sirv-s3-info-overlay').show()
        });

        $('.sirv-s3-info-overlay, sirv-s3-info, sirv-s3-info img').on('click', function(){
          $('.sirv-s3-info-overlay').hide();
        });
          //-----------------------initialization-----------------------
          checkNetworkRadioButton();
          responsiveCheckboxLogic()
          getProfiles();

        });//domready end
    });
</script>
<style type="text/css">
.optiontable.form-table input[type="text"] {max-width: 100%; min-width: 360px;}
.show-result, .sirv-show-result{font-weight: 600; line-height: 1.3; text-align: left;}
nav.nav-tab-wrapper {
    margin: 1.5em 0 1em;
    border-bottom: 1px solid #ccc;
    flex-basis: 100%;
}
.sirv-tab-content { display:none; }
.sirv-tab-content.sirv-tab-content-active { display: block; max-width: 700px; }
.sirv-tab-content .show-result { margin:10px 0 0 0; }
.sirv-tab-content .form-table th,
.sirv-tab-content .form-table td { padding: 10px; }
/* .sirv-tab-content label { display: block; } */
.sirv-tab-content label { display: inline-block; }
.sirv-tab-content p, .sirv-tab-content li { font-size:14px; }

.sirv-optiontable-holder { padding: 10px;  border: 1px solid #ddd; background: #f9f9f9; display: inline-block; margin-bottom:10px; }

.sirv-optiontable-holder table { min-width: 300px; width: 700px; }
.sirv-optiontable-holder table input[type="text"] { width: 100%; }

.form-table th { width: 150px; }

.small-padding th{
  padding-top: 5px !important;
  padding-bottom: 0 !important;
}

.small-padding td{
  padding-top: 6px !important;
  padding-bottom: 0px !important;
}

.small-padding th,
.small-padding td{
  height: 20px;
}

.cache-button-wrapper{padding-top: 10px;}

.required::after{
  content: '*';
  color: red;
}


/* ============================================================
  COMMON
============================================================ */
.cmn-toggle {
  position: absolute;
  margin-left: -9999px;
  visibility: hidden;
}
.cmn-toggle + label {
  display: block;
  position: relative;
  cursor: pointer;
  outline: none;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

/* ============================================================
  SWITCH 1 - ROUND
============================================================ */
input.cmn-toggle-round + label {
  padding: 2px;
  width: 30px;
  height: 15px;
  background-color: #dddddd;
  -webkit-border-radius: 30px;
  -moz-border-radius: 30px;
  -ms-border-radius: 30px;
  -o-border-radius: 30px;
  border-radius: 30px;
  display: inline-block;
}
input.cmn-toggle-round + label:before, input.cmn-toggle-round + label:after {
  display: block;
  position: absolute;
  top: 1px;
  left: 1px;
  bottom: 1px;
  content: "";
}
input.cmn-toggle-round + label:before {
  right: 1px;
  background-color: #f1f1f1;
  -webkit-border-radius: 30px;
  -moz-border-radius: 30px;
  -ms-border-radius: 30px;
  -o-border-radius: 30px;
  border-radius: 30px;
  -webkit-transition: background 0.4s;
  -moz-transition: background 0.4s;
  -o-transition: background 0.4s;
  transition: background 0.4s;
}
input.cmn-toggle-round + label:after {
  width: 17px;
  background-color: #fff;
  -webkit-border-radius: 100%;
  -moz-border-radius: 100%;
  -ms-border-radius: 100%;
  -o-border-radius: 100%;
  border-radius: 100%;
  -webkit-box-shadow: 0 2px 5px rgba(0, 0, 0, 0.3);
  -moz-box-shadow: 0 2px 5px rgba(0, 0, 0, 0.3);
  box-shadow: 0 2px 5px rgba(0, 0, 0, 0.3);
  -webkit-transition: margin 0.4s;
  -moz-transition: margin 0.4s;
  -o-transition: margin 0.4s;
  transition: margin 0.4s;
}
input.cmn-toggle-round:checked + label:before {
  background-color: #8ce196;
}
input.cmn-toggle-round:checked + label:after {
  margin-left: 15px;
}

input.cmn-toggle-round + label + span:before { content: 'Disabled'; color:red; margin-left:5px; top:-2px; font-weight: bold; }
input.cmn-toggle-round:checked + label + span:before { content: 'Enabled'; color:green; }

.s3access-image { margin:0 0 10px 20px; max-width: 100%; }

@media only screen and (max-width: 1199px) {
  .s3access-image { float: none; }
}


.sirv-show-result{ padding-top: 8px; }

.custom-domain{ display: none; }

.error-message { background: red; color:#fff !important; font-weight: bold; }

.sirv-sync-images-progress-block{
  margin-top: 10px;
  display: flex;
}

.sirv-sync-images-progress-bar-wrapper{
    flex-grow: 1;
    border: 1px solid #ccc;
    display: block;
    height: 26px;
    position: relative;
}
.sirv-sync-images-progress-bar{
  /* background-color: #1EB4D4; */
  background-color: #B3D4E5;
  width: 0%;
  height: 100%;
  transition: 0.5s;
}

.sirv-progress-bar-animated{
background-image: -webkit-linear-gradient(bottom left, rgba(255,255,255,.15) 25%, transparent 25%, transparent 50%, rgba(255,255,255,.15) 50%, rgba(255,255,255,.15) 75%, transparent 75%, transparent);
background-image: -o-linear-gradient(bottom left, rgba(255,255,255,.15) 25%, transparent 25%, transparent 50%, rgba(255,255,255,.15) 50%, rgba(255,255,255,.15) 75%, transparent 75%, transparent);
background-image: linear-gradient(to top right, rgba(255,255,255,.15) 25%, transparent 25%, transparent 50%, rgba(255,255,255,.15) 50%, rgba(255,255,255,.15) 75%, transparent 75%, transparent);

-webkit-background-size: 40px 40px;
background-size: 40px 40px;


  animation: progress 1s linear infinite;
}

@keyframes progress {
    from { background-position:  0px; }
    to   { background-position: 40px; }
}

@-webkit-keyframes progress {
    from { background-position:  0px; }
    to   { background-position: 40px; }
}



.sirv-sync-images-progress-text{
  position: absolute;
  left: 0%;
  right: 0;
  bottom: 0;
  top:0;
  text-align: center;
  line-height: 28px;
  display: inline-block;
}

.sync-cache-button-wrapper{
  flex-grow: 0;
  padding-left: 5px;
  /* display: none; */
}
.sync-cache-button-wrapper input {
height: 30px;
}

.disabled-tab{
  position: absolute;
  top: 0;
  left: 0;
  width: 43%;
  height: 100%;
  z-index: 9999999999;
  background-color: rgba(0, 0, 0, 0.4);
}

#sirv-cache{
  position: relative;
}

.invalidate-cache-button-wrapper, .purge-cache-button-wrapper{margin-top: 5px;}


.sirv-traffic-loading{
  position: relative;
  text-align: center;
}

.sirv-traffic-loading-ico{
  margin-left: 22px;
}

.sirv-traffic-loading-ico::before{
  content: '';
  display: inline-block;

  border: 2px solid rgba(0, 0, 0, 0.3);
  border-left: 2px solid rgba(0, 0, 0, 1);
  border-top: 2px solid rgba(0, 0, 0, 1);
  border-bottom: 2px solid rgba(0, 0, 0, 1);
  border-radius: 50%;
  width: 12px;
  height: 12px;
  -webkit-animation: load 1.1s infinite linear;
  animation: load 1s infinite linear;
  z-index: 1;
  margin: auto;
  position: relative;
  top: 3px;
  margin-right: 5px;
}

@-webkit-keyframes load {
    0% {
        -webkit-transform: rotate(0deg);
        transform: rotate(0deg);
    }
    100% {
        -webkit-transform: rotate(360deg);
        transform: rotate(360deg);
    }
}
@keyframes load {
    0% {
        -webkit-transform: rotate(0deg);
        transform: rotate(0deg);
    }
    100% {
        -webkit-transform: rotate(360deg);
        transform: rotate(360deg);
    }
}

.sirv-hide { display: none; }

.sirv-tf-loading-error { padding: 5px; }

.optiontable.form-table tr:first-child td h2:first-child { margin-top: 0px; }
.optiontable.form-table h2 { margin-bottom: 10px; }
.optiontable.form-table h3 { margin: 0px 0 10px 0; }

.sirv-form-table th { width: 115px !important; }

.sirv-st-total { font-weight: bold;  }
.sirv-st-used span,
.sirv-st-available span { color: #818a91; }

.graph-bar-wrapper{
  width: 100%;
  height: 18px;
  border-top: 1px solid #D1D1D1;
  border-right: 1px solid #D1D1D1;
  border-left: 1px solid #D1D1D1;
  border-bottom: 1px solid #D1D1D1;
  vertical-align: top;
}
.graph-bar{
  background-color: #E0F2B5;
  height: 18px;
  display: block;
}
.traffic-wrapper > tr:last-child .graph-bar-wrapper {
  border-bottom: 1px solid #D1D1D1;
}
.traffic-wrapper tr>td:nth-child(3){ min-width: 68px; max-width: 85px; }

/* .traffic-wrapper tr:first-child td { padding-left: 10px !important; } */
.traffic-wrapper tr td:last-child { padding-left: 0; }
.traffic-wrapper tr>td:nth-child(2) {
    padding-right: 1px;
    padding-left: 0;
    min-width: 65px;
    max-width: 75px;
    width: 75px;
}


.sirv-optiontable-holder select{ width: 90%; }

.sirv-width-max { width: 100% !important; }

/* .sirv-profiles-wrapper table th { padding: 20px 10px 20px 0 !important; } */

.sirv-option-responsive-text {
    font-size: 13px;
    /* margin-top: 9px; */
    vertical-align: middle;
    padding-bottom: 5px;
}
.sirv-beta-text {
    color: orange;
}

.sync-errors {
    display: none;
    color: white;
    background-color: #e57272;
    border-radius: 10px;
    padding: 10px;
}

.sync-errors hr{
  border-top: none;
  margin: 12px -10px;
  opacity: 0.3;
}

.sync-errors hr:first-child {
    display: none;
}

.sirv-error-list-images-wrap{
  width: auto;
  max-height: 250px;
  margin-bottom: 5px;
  font-weight: normal;
  display: none;
  margin-top: 15px;
  overflow-y: auto;
}

.sirv-error-list-images-title {
    width: auto;
    height: 20px;
    text-align: center;
    border: 1px solid;
    cursor: pointer;
    display: none;
}


.sirv-show-hide-list {
    border: 1px solid white;
    background-color: white;
    color: #e57272;
    padding: 5px;
    border-radius: 5px;
    cursor: pointer;
    /* margin-left: 20px;
    font-weight: normal;
    text-decoration: underline; */
    margin-top: 5px;
}

.sirv-error-list-images{
  /* put code here */
}

.sirv-error-list-images a{
  color: #FFF;
}

.sirv-error-list-images a:hover{
  font-weight: bold;
}

.sirv-flat {
    display: inline-block !important;
}

#sirv-instructions { max-width: 100%; }
#sirv-instructions h2 { margin-top: 1.5em; font-size: 1.5em;}
#sirv-instructions img { width: 100%; }
#sirv-instructions img.card { box-shadow: 0 4px 8px 0 rgba(0, 0, 0, 0.2), 0 6px 20px 0 rgba(0, 0, 0, 0.19); margin-bottom: 24px; height: auto; padding: 0; max-width: 650px;}
/* #sirv-instructions ul { list-style-type: circle; padding-left: 5%; }*/

.sirv-show-account-tab{
  color: white;
  text-decoration: underline;
  font-weight: normal;
}

.sirv-show-account-tab:hover{
  color: white;
  cursor: pointer;
  font-weight: bold;
}

.sirv-s3-info-icon {
    cursor: pointer;
    margin-left: 5px;
}

.sirv-s3-info-overlay {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba(45,45,45, 0.9);
    text-align: center;
    z-index: 10000;
}

.sirv-s3-info-title {
    color: red;
    font-size: 30px;
    padding-bottom: 10px;
}

.sirv-s3-info {
    position: relative;
    display: inline-block;
    top: 35%;
}

.sirv-s3-info img {
    box-shadow: 0 0 15px rgba(0,0,0,0.6);
    max-width: 100%;
    width: 90%;
}

.sirv-no-select-text{
  -webkit-touch-callout: none; /* iOS Safari */
    -webkit-user-select: none; /* Safari */
     -khtml-user-select: none; /* Konqueror HTML */
       -moz-user-select: none; /* Firefox */
        -ms-user-select: none; /* Internet Explorer/Edge */
            user-select: none; /* Non-prefixed version, currently
                                  supported by Chrome and Opera */
}

.sirv-wrapped-nav {
  background-image: url("<?php echo plugin_dir_url( __FILE__ ) . "assets/logo.svg" ?>");
  background-position: top right;
  background-repeat: no-repeat;
  background-size: 128px 128px;
  display: flex;
  justify-content: space-between;
  min-height: 150px;
  flex-direction: column;
}

.sirv-wrapped-nav .nav-tab{
  font-size: 18px;
  font-weight: 500;
}

.nav-tab-wrapper .dashicons { display: none; }

.sirv-sirv-options-php .wrap { margin: 20px 20px 0 10px; }

.sirv-sirv-options-php .sirv-options-title {
    margin: .2em 200px 0 0;
    padding: 0 !important;
    color: #32373c !important;
    line-height: 1.2em !important;
    font-size: 2.8em !important;
    font-weight: 400 !important;
}

p.sirv-options-desc{ max-width: 700px; }

.sirv-storage-traffic-wrapper {
    display: flex;
    justify-content: space-between;
    flex-direction: row;
}

.sirv-storage-traffic-wrapper .sirv-optiontable-holder{
  flex-basis: calc(50% - 5px);
  flex-grow: 0;
  box-sizing: border-box;
}

.sirv-storage-traffic-wrapper .sirv-optiontable-holder table{ max-width: 700px; width: 100%; }

#sirv-stats .sirv-optiontable-holder{ display: block; }

.sirv-no-lmargin { margin-left: 0; }

.sirv-network-wrapper label{ padding-bottom: 5px; }

.sirv-help-wrapper {
    display: flex;
    flex-direction: row;
}

.sirv-help-menu {
    flex-basis: 250px;
}

.sirv-help-data { flex-basis: 100%; padding-left: 90px; border-left: 1px solid #cdcdcd; }
.sirv-help-menu ul { list-style-type: none !important;  width: 220px; /*margin-right: 10px; */ }
.sirv-help-menu ul li { padding: 6px; }

.sirv-help-menu-fixed { position: fixed; top: 30px; }
/* .sirv-help-menu-fixed ul { width: 220px; } */

.sirv-help-data-margin { margin-left: 220px; }

.sirv-anchor-help{
  padding-top: 55px;
  margin-top: -55px;
  display: block;
}

.sirv-help-menu ul li a { text-decoration: none; color: #646a6f; display: block;}
.sirv-help-menu ul li a:hover { text-decoration: underline; }
.sirv-help-menu ul li a:focus { box-shadow: none !important; }

.sirv-help-menu ul li.active {
  border-right: 3px solid black;
}
.sirv-help-menu ul li.active a{
  font-weight: 600;
  font-size: 1.2em;
  text-decoration-line: none;
  color: #0073aa;
}

@media only screen and (max-width: 767px) {
  .sirv-wrapped-nav { background-image: none; }
  .optiontable.form-table input[type="text"] { min-width: 300px; width: 100%; }
  .sirv-optiontable-holder table { max-width: 100%; width: 100% }
  .sirv-optiontable-holder  { display: block; }
  .form-table th { width: auto; }
  #sirv-stats .form-table th, #sirv-stats .form-table td { display: table-cell; }
  .sirv-storage-traffic-wrapper { flex-direction: column; }
  .sirv-storage-traffic-wrapper .sirv-optiontable-holder { flex-basis: 100%; box-sizing: none; }
  .sirv-tab-content .form-table th { padding: 0; }
  .sirv-tab-content .form-table td { padding: 5px 0 10px 0; }
  .sirv-sync-images-progress-text { font-size: 0.9em; }
  #sirv-cache .form-table td,
  #sirv-cache .form-table th { display: table-cell; }

  .sirv-tab-txt{ display: none; }
  .nav-tab-wrapper .dashicons {
    display: inherit;
    width: 25px;
    height: 25px;
    font-size: 25px;
  }

  .sirv-sirv-options-php .nav-tab {margin: 0 0 -1px 0;}
  .sirv-sirv-options-php .sirv-options-title { margin: 0;}

  .sirv-help-wrapper { display: block; }

  .sirv-help-menu ul { width: 200px; }
  .sirv-help-data { border-left: none; padding-left: 0; }
}
</style>

<div class="wrap">
    <div class="sirv-s3-info-overlay" style="display: none;">
      <div class="sirv-s3-info sirv-no-select-text">
        <img src="<?php echo plugin_dir_url( __FILE__ ) . "assets/s3access.png" ?>" />
      </div>
    </div>

    <form action="options.php" method="post" id="sirv-save-options">

        <?php wp_nonce_field('update-options'); ?>

        <?php
            $active_tab = (isset($_POST['active_tab']))? $_POST['active_tab'] : '#sirv-account';
        ?>
        <div class="sirv-wrapped-nav">
          <h1 class="sirv-options-title">Welcome to Sirv</h1>
          <nav class="nav-tab-wrapper">
              <a class="nav-tab nav-tab-sirv-account <?php echo ( $active_tab=='#sirv-account' )?'nav-tab-active':'' ?>" href="#sirv-account"><span class="dashicons dashicons-admin-users"></span><span class="sirv-tab-txt">Account &amp; CDN</span></a>
              <?php //if (get_option('WP_USE_SIRV_CDN')) { ?>
              <a class="nav-tab nav-tab-sirv-cache <?php echo ( $active_tab=='#sirv-cache' )?'nav-tab-active':'' ?>" href="#sirv-cache"><span class="dashicons dashicons-update"></span><span class="sirv-tab-txt">Synchronization</span></a>
              <?php //} ?>
              <?php if ($testConnection) { ?>
              <a class="nav-tab nav-tab-sirv-stats <?php echo ( $active_tab=='#sirv-stats' )?'nav-tab-active':'' ?>" href="#sirv-stats"><span class="dashicons dashicons-chart-bar"></span><span class="sirv-tab-txt">Stats</span></a>
              <?php } ?>
              <a class="nav-tab nav-tab-sirv-help <?php echo ( $active_tab=='#sirv-instructions' )?'nav-tab-active':'' ?>" href="#sirv-instructions"><span class="dashicons dashicons-editor-help"></span><span class="sirv-tab-txt">Help</span></a>
              <a class="nav-tab nav-tab-sirv-feedback<?php echo ( $active_tab=='#help-feedback' )?'nav-tab-active':'' ?>" href="#help-feedback"><span class="dashicons dashicons-feedback"></span><span class="sirv-tab-txt">Feedback</span></a>
          </nav>
        </div>

        <div class="sirv-tab-content sirv-tab-content-active" id="sirv-account">


          <h2>Connect your Sirv account</h2>

          <p>Enter your S3 credentials from your <a target="_blank" href="https://my.sirv.com/#/account/">Sirv account page</a>.</p>

          <div class="sirv-s3credentials-wrapper">
            <div class="sirv-optiontable-holder">
                <table class="optiontable form-table">
                    <?php if ((!$testConnection && ( !empty($bucket) || !empty($key) || !empty($secret_key)) || $sirv_authMessage )) { ?>
                    <tr>
                        <th class="error-message" colspan="2"><?php if($sirv_authMessage){echo $sirv_authMessage;}else{echo "Wrong account settings. Can't connect to Sirv.";}?></th>
                    </tr>
                    <?php } ?>
                    <tr>
                        <th><label>S3 Bucket</label><a class="sirv-s3-info-icon"><span class="dashicons dashicons-info"></span></a></th>
                        <td><input type="text" name="AWS_BUCKET" value="<?php echo get_option('AWS_BUCKET'); ?>"></td>
                    </tr>
                    <tr>
                        <th><label>S3 Key</label><a class="sirv-s3-info-icon"><span class="dashicons dashicons-info"></span></a></th>
                        <td><input type="text" name="AWS_KEY" value="<?php echo get_option('AWS_KEY'); ?>"></td>
                    </tr>
                    <tr>
                        <th><label>S3 Secret</label><a class="sirv-s3-info-icon"><span class="dashicons dashicons-info"></span></a></th>
                        <td><input type="text" name="AWS_SECRET_KEY" value="<?php echo get_option('AWS_SECRET_KEY'); ?>"></td>
                    </tr>
                    <tr>
                        <th></th>
                        <td>
                            <input type="button" class="button-primary test-connect" value="Test connection">
                            <input type="submit" name="submit" class="button-primary" value="<?php _e('Save Settings') ?>" />
                            <div class="show-result"></div>
                        </td>
                    </tr>
                </table>
            </div>
          </div>
          <br>
          <div class="sirv-network-wrapper">
            <h2>Enable the Sirv CDN</h2>

            <p class="sirv-options-desc">
                Your images will be automatically copied to Sirv, optimized, resized and delivered fast by Sirv. Includes featured images, gallery images, WooCommerce & Jigoshop images, plus any other image added to your WordPress media library via a plugin or script.
            </p>

            <div class="sirv-optiontable-holder">
                <table class="optiontable form-table">
                    <tr><th>
                            <label>Network status</label>
                        </th>
                        <td>
                            <!--<input type="checkbox" class="cmn-toggle cmn-toggle-round" name="WP_USE_SIRV_CDN" id="WP_USE_SIRV_CDN" value='1' "<?php checked('1', get_option('WP_USE_SIRV_CDN')); ?>">
                            <label for="WP_USE_SIRV_CDN"></label>
                            <span></span>
                            <input type="checkbox" name="WP_USE_SIRV_CDN" id="WP_USE_SIRV_CDN" value='1' "<?php checked('1', get_option('WP_USE_SIRV_CDN')); ?>">-->
                            <label><input type="radio" name="WP_USE_SIRV_CDN" value='2' "<?php checked(2, get_option('WP_USE_SIRV_CDN'), true); ?>">Disabled</label><br />
                            <label><input type="radio" name="WP_USE_SIRV_CDN" value='1' "<?php checked(1, get_option('WP_USE_SIRV_CDN'), true); ?>">Enabled</label>
                        </td>
                    </tr>
                    <tr>
                        <th>
                            <label>Network</label>
                        </th>
                        <td>
                            <label><input type="radio" name="WP_SIRV_NETWORK" value='1' "<?php checked(1, get_option('WP_SIRV_NETWORK'), true); ?>"><b>CDN</b> - deliver images from global server network (24-hour cache delay).</label>
                            <label><input type="radio" name="WP_SIRV_NETWORK" value='2' "<?php checked(2, get_option('WP_SIRV_NETWORK'), true); ?>"><b>DIRECT</b> - deliver images from primary Sirv datacentre (no cache delay).</label>
                            <label><input type="radio" name="WP_SIRV_NETWORK" value='3' "<?php checked(3, get_option('WP_SIRV_NETWORK'), true); ?>"><b>CUSTOM</b> - deliver images from CDN with your own domain (<a target="_blank" href="https://sirv.com/help/resources/custom-domain/">learn more</a>).</label>
                        </td>
                    </tr>
                    <tr class='custom-domain'>
                        <th>
                            <label>Custom domain</label>
                        </th>
                        <td><input type="text" name="WP_SIRV_CUSTOM_DOMAIN" value="<?php echo get_option('WP_SIRV_CUSTOM_DOMAIN'); ?>" placeholder='e.g. cdn.mydomain.com'></td>
                    </tr>
                    <tr>
                        <th>
                            <label>Folder name on Sirv</label>
                        </th>
                        <td><input type="text" name="WP_FOLDER_ON_SIRV" value="<?php echo get_option('WP_FOLDER_ON_SIRV'); ?>"></td>
                    </tr>
                    <tr>
                        <th>
                        </th>
                        <td><input type="submit" name="submit" class="button-primary" value="<?php _e('Save Settings') ?>" /></td>
                    </tr>
                </table>
            </div>
          </div>
            <br />
            <div class="sirv-profiles-wrapper" <?php if (!$testConnection) echo 'style="display: none;"' ?> >
              <!-- profiles options-->
              <h2>Image settings</h2>
              <p class="sirv-options-desc">Select a profile to change the image style. Use it to add watermarks, text overlays or other profile effects. Create or change profiles on your <a target="_blanc" href="https://my.sirv.com/#/profiles/">Sirv profiles page</a>.</p>
              <div class="sirv-optiontable-holder">
                  <table class="optiontable form-table">
                       <tr>
                          <th>
                              <label>Featured images &amp; post thumbnails</label>
                          </th>
                          <td>
                            <span class="sirv-traffic-loading-ico sirv-shortcodes-profiles"></span>
                            <select id="sirv-cdn-profiles"><option>fetching data..</option></select>
                            <input type="hidden" id="sirv-cdn-profiles-val" name="WP_SIRV_CDN_PROFILES" value="<?php echo get_option('WP_SIRV_CDN_PROFILES'); ?>">
                          </td>
                      </tr>
                      <tr>
                          <th>
                              <label>Shortcodes</label>
                          </th>
                          <td>
                            <span class="sirv-traffic-loading-ico sirv-shortcodes-profiles"></span>
                            <select id="sirv-shortcodes-profiles"><option>fetching data..</option></select>
                            <input type="hidden" id="sirv-shortcodes-profiles-val" name="WP_SIRV_SHORTCODES_PROFILES" value="<?php echo get_option('WP_SIRV_SHORTCODES_PROFILES'); ?>">
                          </td>
                      </tr>
                      <tr>
                        <th>
                          <label style="padding-bottom: 10px;">Lazy loading</label>
                        </th>
                        <td>
                            <!--<input type="checkbox" class="cmn-toggle cmn-toggle-round" name="WP_USE_SIRV_RESPONSIVE" id="WP_USE_SIRV_RESPONSIVE" value='1' "<?php checked('1', get_option('WP_USE_SIRV_RESPONSIVE')); ?>">
                            <label for="WP_USE_SIRV_RESPONSIVE"></label>
                            <span></span>-->
                            <label><input type="checkbox" name="WP_USE_SIRV_RESPONSIVE" id="WP_USE_SIRV_RESPONSIVE" value='1' "<?php checked('1', get_option('WP_USE_SIRV_RESPONSIVE')); ?>"><span class="sirv-option-responsive-text">Load images on demand & scale them appropriately, if possible.
Deactivate any other lazy loading plugins. Sirv will serve scaled images, loaded on demand. Please check your webpage images after activation.</span></label>
                        </td>
                      </tr>
                      <tr>
                          <th>
                          </th>
                          <td><input type="submit" name="submit" class="button-primary" value="<?php _e('Save Settings') ?>" /></td>
                      </tr>
                  </table>
              </div>
            </div>


            <div class="sirv-miscellaneous-wrapper" >
              <h2>Miscellaneous</h2>
              <div class="sirv-optiontable-holder">
                  <table class="optiontable form-table">
                    <tr>
                          <th>
                              <label>Always load sirv.js</label>
                          </th>
                          <td>
                            <label><input type="checkbox" name="WP_SIRV_ALWAYS_ADD_HEADERS" id="WP_SIRV_ALWAYS_ADD_HEADERS" value='1' "<?php checked('1', get_option('WP_SIRV_ALWAYS_ADD_HEADERS')); ?>"><span class="sirv-option-responsive-text">If images don't load, activate this option.</span></label>
                          </td>
                      </tr>
                      <tr>
                          <th>
                          </th>
                          <td><input type="submit" name="submit" class="button-primary" value="<?php _e('Save Settings') ?>" /></td>
                      </tr>
                  </table>
              </div>
            </div>

            <!-- END Account&CDN options-->

            <input type="hidden" name="active_tab" id="active_tab" value="#sirv-account" />
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="AWS_KEY,AWS_SECRET_KEY, AWS_BUCKET, WP_FOLDER_ON_SIRV, WP_USE_SIRV_CDN, WP_SIRV_NETWORK, WP_SIRV_CUSTOM_DOMAIN, WP_SIRV_SHORTCODES_PROFILES, WP_SIRV_CDN_PROFILES, WP_USE_SIRV_RESPONSIVE, WP_SIRV_ALWAYS_ADD_HEADERS" />

<!--             <p><input type="submit" name="submit" class="button-primary" value="<?php _e('Save Settings') ?>" /></p>
 -->
        </div>


        <div class="sirv-tab-content" id="sirv-cache">
        <?php if (!get_option('WP_USE_SIRV_CDN')) { ?>
          <!-- <div class="disabled-tab"></div> -->
        <?php } ?>

            <h2>Synchronization</h2>
            <p class="sirv-options-desc">Automatically copy your WordPress media library to Sirv, for better optimization and fast CDN delivery.</p>

            <div class="sirv-optiontable-holder">
                <table class="optiontable form-table">
                <?php if (get_option('WP_USE_SIRV_CDN') != 1 ) { ?>
                  <tr>
                      <th class="error-message" colspan="2"><span style="font-size: 15px;font-weight: 800;">Disabled:</span> to use these options, please enable the Sirv CDN on the <a class="sirv-show-account-tab">Account &amp; CDN tab</a></th>
                  </tr>
                <?php } ?>
                    <tr>
                      <td colspan="2">
                        <h3>Status</h3>
                      </td>
                    </tr>
                    <tr class="small-padding">
                        <th><label style="white-space:nowrap;">Synchronized images</label></th>
                        <td><span class="cache-img-num"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                    </tr>
                    <tr class="small-padding">
                        <th><label>Total files size</label></th>
                        <td><span class="cache-size"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                    </tr>

                    <?php if ($testConnection) { ?>
                    <tr>
                      <td colspan="2">
                      <h2>Progress</h2>
                        <p class="sirv-options-desc">Images are copied to Sirv the first time they are viewed, which can take 1-2 seconds per image. To perform a full synchronization now, click Sync images:</p>
                      </td>
                    </tr>
                    <tr class="small-padding"><th colspan="2">
                    <div class="sirv-sync-images-progress-block">
                      <div class="sirv-sync-images-progress-bar-wrapper">
                        <div class="sirv-sync-images-progress-bar"></div>
                        <div class="sirv-sync-images-progress-text"></div>
                      </div>
                      <div class="sync-cache-button-wrapper">
                        <input type="button" name="sirv-sync-images" class="button-primary sirv-sync-images" value="Sync images" />
                      </div>
                    </div>
                    </th>
                    </tr>
                    <tr class="sync-errors-wrap">
                      <th colspan="2">
                        <div class="sync-errors"></div>
                      </th>
                    </tr>
                    <?php } ?>
                    <tr>
                      <td colspan="2">
                        <span>
                            <h2>Re-Synchronize</h2>
                      </span>
                      </td>
                    </tr>
                    <tr class="small-padding">
                        <td colspan="2">
                            <b>Fast</b>
                            <p class="sirv-options-desc">Delete the list of synced images, if synchronization does not fully complete.</p>
                            <div class="invalidate-cache-button-wrapper">
                              <input type="button" name="invalidate-cache" class="button-primary invalidate-cache" value="Clear database" />
                              <div style="display: inline; margin-left: 5px; font-weight: bold;" class="invalidate-cache-result"></div>
                            </div>
                            <br/>
                            <b>Full</b>
                            <p class="sirv-options-desc">Delete the images copied to your Sirv account - useful if you deleted many images from your WordPress library and wish to also delete them from Sirv. Your library will automatically re-sync.</p>
                            <div class="purge-cache-button-wrapper">
                              <input type="button" name="purge-cache" class="button-primary purge-cache" value="Delete images from Sirv" />
                              <div style="display: inline; margin-left: 5px; font-weight: bold;" class="purge-cache-result"></div>
                            </div>
                            <!-- <br>
                            <div class="debug-button-wrapper">
                              <input type="button" name="debug-button" class="button-primary debug-button" value="Debug" />
                            </div> -->
                        </td>
                    </tr>
                    <!-- test clean 30 rows in table -->
                    <!-- <tr>
                      <td colspan="2">
                        <div class="test-clean-30-rows-wrapper">
                          <input type="button" name="test-clean-30-rows" class="button-primary test-clean-30-rows" value="Clean 30 rows" />
                          <div style="display: inline; margin-left: 5px; font-weight: bold;" class="test-clean-30-rows-result"></div>
                        </div>
                      </td>
                    </tr> -->
                </table>
            </div>
        </div>

        <?php if (true || $testConnection) { ?>
        <div class="sirv-tab-content" id="sirv-stats">
          <h2>Stats</h2>
          <p class="sirv-options-desc">Check how much storage and transfer your Sirv account is using.</p>
            <div class="sirv-optiontable-holder">
              <table class="optiontable form-table sirv-form-table">
                <!-- <tr>
                  <td colspan="2">
                    <h2>Stats</h2>
                    <p class="sirv-options-desc">Check how much storage and transfer your Sirv account is using.</p>
                  </td>
                </tr> -->
                <tr class="small-padding">
                  <th><label style="white-space:nowrap;">Account</label></th>
                  <td><span class="sirv-account-name"><?php echo get_option('AWS_BUCKET'); ?></span></td>
                </tr>
                <tr class="small-padding">
                  <th><label style="white-space:nowrap;">Plan</label></th>
                  <td><span class="sirv-account-plan"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></span></td>
                </tr>
              </table>
            </div>

          <div class="sirv-storage-traffic-wrapper">
            <div class="sirv-optiontable-holder">
              <table class="optiontable form-table sirv-form-table">
                <tr>
                  <td colspan="2">
                    <h3>Storage</h3>
                  </td>
                </tr>
                <tr class="small-padding">
                    <th><label>Allowance</label></th>
                    <td><span class="sirv-st-total"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                </tr>
                <tr class="small-padding">
                    <th><label>Used</label></th>
                    <td><span class="sirv-st-used"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                </tr>
                <tr class="small-padding">
                    <th><label>Available</label></th>
                    <td><span class="sirv-st-available"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                </tr>
                <tr class="small-padding">
                    <th><label>Files</label></th>
                    <td><span class="sirv-st-files"><span class="sirv-traffic-loading-ico"></span> fetching data..</span></td>
                </tr>
              </table>
            </div>

            <div class="sirv-optiontable-holder">
              <table class="optiontable form-table sirv-form-table">
                <tr>
                  <td>
                    <h3>Transfer</h3>
                  </td>
                </tr>
                <tbody cellspacing="0" class="optiontable form-table sirv-form-table traffic-wrapper">
                <tr class='tf-show-block'>
                  <td colspan="2">
                    <div class="sirv-traffic-loading"><span class="sirv-traffic-loading-ico">Calculating traffic...</span></div>
                    <div class="error-message sirv-tf-loading-error sirv-hide"></div>
                  </td>
                </tr>
                </tbody>
              </table>
            </div>
          </div>
          </div>
        <?php } ?>


        <div class="sirv-tab-content" id="sirv-instructions">
          <div class="sirv-help-wrapper">
                <div class="sirv-help-menu">
                  <ul class="sirv-nav">
                    <li class="active"><a href="#sirv-help-setup">Setup your account</a></li>
                    <li><a href="#sirv-help-sync">Sync your Media Library</a></li>
                    <li><a href="#sirv-help-upload-images">Upload images</a></li>
                    <li><a href="#sirv-help-static">Embed static images</a></li>
                    <li><a href="#sirv-help-responsive">Embed responsive images</a></li>
                    <li><a href="#sirv-help-gallery">Embed image galleries</a></li>
                    <li><a href="#sirv-help-zoom-image">Embed zoom images</a></li>
                    <li><a href="#sirv-help-zoom-galleries">Embed zoom galleries</a></li>
                    <li><a href="#sirv-help-spin">Embed 360 spins</a></li>
                    <li><a href="#sirv-help-zoom-and-spin">Embed spins & zooms</a></li>
                    <li><a href="#sirv-help-serve-other-files">Serve other files</a></li>
                    <li><a href="#sirv-help-learn-more">Learn more about Sirv</a></li>
                  </ul>
                </div>
                <div class="sirv-help-data">
                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-setup"></a>
                    Setup your account
                  </h2>

                  <p>It's easy to serve your website images with Sirv.</p>

                  <p>In under 5 minutes, you'll have the best optimized WordPress website possible.</p>

                  <p>1. Start by <a href="https://my.sirv.com/#/signup:" target="_blank">creating a free Sirv account</a> (30 seconds and no credit card needed).</p>

                  <p>2. Go to the <a href="https://my.sirv.com/#/account/settings/settings" target="_blank">settings page</a> of your Sirv account and copy your Sirv S3 settings:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/sirv-s3-settings.png?profile=wp-plugin-help" height="285" class="card" alt=""></p>

                  <p>3. Copy the S3 settings and paste them into your WordPress plugin:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/copy-paste-the-S3-settings.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. Save the settings.</p>

                  <p>Now you can sync your WordPress library, upload images to Sirv and embed images with Sirv.</p>

                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-sync"></a>
                    Sync your Media Library
                  </h2>

                  <p>Sirv can serve your WordPress media library faster than your own server can.</p>

                  <p>First, it synchronizes your media library to your Sirv account. Then it serves your images from Sirv instead of your server.</p>

                  <p>Images are perfectly sized and incredibly well optimized. They are delivered to each visitor by the closest server on Sirv's fast global CDN.</p>

                  <p>1. Enable the Sirv CDN:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/simply-enable-the-Sirv-CDN.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Sirv will fetch the images from your server the first time they are requested.</p>

                  <p>Images will automatically stay in sync whenever you upload new images.</p>

                  <p>3. Go to the Synchronization tab to check the status. To trigger a full sync of all images, click the <strong>Sync Images</strong> button:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/check-the-status-of-synchronization.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-upload-images"></a>
                    Upload images
                  </h2>

                  <p>You can either upload images to the WordPress media library (and Sirv will sync them if you enable the CDN) or you can upload images directly to your Sirv media library.</p>

                  <p>Upload directly to Sirv in various ways:</p>

                  <ol>
                  <li>Browser</li>
                  <li>FTP</li>
                  <li>S3</li>
                  </ol>

                  <p>To upload through your browser, either drag and drop images into your <a href="admin.php?page=sirv/sirv/media_library.php" target="_blank">Sirv Media Library</a>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/upload-through-your-browser.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>You can also upload images after clicking <strong>Add Sirv Media</strong> from any page/post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-Sirv-Media-from-any-page.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Upload by FTP by copying <a href="https://my.sirv.com/#/account/settings" target="_blank">your Sirv FTP settings</a>. Either <a href="https://sirv.com/help/resources/upload-images-with-filezilla/" target="_blank">configure FileZilla</a> or another FTP program.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-static"></a>
                    Embed static images
                  </h2>

                  <p>Static images are fixed in width or height. Whatever width or height you choose, Sirv will generate a new perfectly sized image on-the-fly. You can also add options to crop, change the canvas, add watermarks, add text, rotate, adjust colours, vignette and borders. See examples of all the <a href="https://sirv.com/help/resources/dynamic-imaging/%5Ddynamic" target="_blank">dynamic</a> imaging options[/a].</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the image(s) you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/static-image-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/static-image-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. You will see your image(s) embedded in your page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/static-image-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the image(s) in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/static-image-save-and-enjoy.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-responsive"></a>
                    Embed responsive images
                  </h2>

                  <p>Responsive images are perfectly resized to fit the screen. During page load, Sirv detects the users' device, browser and screen size and generates an ideal image. This prevents images being larger than necessary and speeds up page loading.</p>

                  <p>Images can also be lazy loaded, if they come into view. This can also reduce the total size of your page significantly and speed up loading.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the image(s) you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/responsive-images-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/responsive-images-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. You will see your image(s) embedded in your page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/responsive-images-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the image(s) in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/responsive-images-save-and-enjoy.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-gallery"></a>
                    Embed image galleries
                  </h2>

                  <p>Image galleries are a great way to display lots of images. Galleries have one large image and lots of small images. Click the small images to swap the large image.</p>

                  <p>Images are dynamically generated on-the-fly, to perfectly fit the users screen - not too big, not too small. Served over Sirv's CDN, its a fast and easy way to serve beautiful photo galleries.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the image(s) you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-gallery-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-gallery-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. You will see your images embedded in your page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-gallery-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the images in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-gallery-save-and-enjoy.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Get some inspiration! Check out <a href="https://sirv.com/demos/" target="_blank">11 examples</a> of zoom, responsive and 360 spin images using Sirv.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-zoom-image"></a>
                    Embed zoom images
                  </h2>

                  <p>Sirv Zoom quickly zooms deep inside large images. The bigger your image, the better. They always load fast - even huge images - because of the way Sirv generates hundreds of tiny square images. Just like Google Maps, you can zoom and pan any image, effortlessly.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the image you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-zoom-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-zoom-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. Your image will show as a gallery. You can edit it with the settings icon and delete it with the X icon.</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-zoom-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the image in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/image-zoom-save-and-enjoy.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Get some inspiration! Check out <a href="https://sirv.com/demos/" target="_blank">11 examples</a> of zoom, responsive and 360 spin images using Sirv.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-zoom-galleries"></a>
                    Embed zoom galleries
                  </h2>

                  <p>Sirv Zoom images can be embedded as a gallery. Perfectly for displaying lots of high resolution images, it has a stunning full-screen option that enlarges your image to the entire screen. Click between thumbnails to swap the images.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the images you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/zoom-gallery-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/zoom-gallery-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. Your images will show as a gallery, with arrows to navigate between thumbnails. You can edit it with the settings icon and delete it with the X icon.</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/zoom-gallery-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the images in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/zoom-gallery-save-and-enjoy.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Get some inspiration! Check out <a href="https://sirv.com/demos/" target="_blank">11 examples</a> of zoom, responsive and 360 spin images using Sirv.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-spin"></a>
                    Embed 360 spins
                  </h2>

                  <p>Sirv Spin is the ultimate way to embed 360 spinning images in your site. Images automatically scale to fit the page or can be embedded at a fixed size. They load fast and can contain watermarks, text overlays and image effects.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the spin you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/360-spin-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/360-spin-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. Your spin will show as a gallery. You can edit it with the settings icon and delete it with the X icon.</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/360-spin-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>5. Save your page and enjoy the spin in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/360-spin-save-and-enjoy.gif?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Get some inspiration! Check out <a href="https://sirv.com/demos/" target="_blank">11 examples</a> of zoom, responsive and 360 spin images using Sirv.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-zoom-and-spin"></a>
                    Embed spins &amp; zooms
                  </h2>

                  <p>Show a mixture of zoomable images and 360 spin images. Sirv can create a gallery of images and display them as a main image with thumbnails to switch image. A great way to showcase products with 360 spins and highly detailed zooms.</p>

                  <p>1. Click the <strong>Add Sirv Media</strong> button on a page or post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/add-sirv-media.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>2. Click the spins and images you wish to embed:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/spin-and-zoom-click-the-image.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>3. Choose your options and click Insert into page:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/spin-and-zoom-choose-your-options.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>4. Your spins and zooms will show as a gallery. You can edit it with the settings icon and delete it with the X icon.</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/spin-and-zoom-see-your-images.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>.5. Save your page and enjoy the spin/zoom gallery in your post:</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/spin-and-zoom-save-and-enjoy.gif?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <p>Get some inspiration! Check out <a href="https://sirv.com/demos/" target="_blank">11 examples</a> of zoom, responsive and 360 spin images using Sirv.</p>


                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-serve-other-files"></a>
                    Serve other files
                  </h2>

                  <p>Rapidly serve your other files from Sirv too. It is designed to quickly deliver any static files over its global CDN using HTTPS to all your users around the world.</p>

                  <p>All kinds of file can be served:</p>

                  <ul>
                  <li>CSS</li>
                  <li>JS</li>
                  <li>SVG</li>
                  <li>ICO</li>
                  <li>PDF</li>
                  <li>CSV</li>
                  <li>XML</li>
                  <li>Fonts</li>
                  <li>Documents</li>
                  <li>Spreadsheets</li>
                  <li>Presentations</li>
                  </ul>

                  <p>Upload your images to your Sirv account, then copy the CDN link and use it in your page.</p>

                  <p><img src="https://sirv-cdn.sirv.com/website/screenshots/wordpress/serve-other-files.png?profile=wp-plugin-help" height="500" class="card" alt=""></p>

                  <h2>
                    <a class="sirv-anchor-help" id="sirv-help-learn-more"></a>
                    Learn more about Sirv
                  </h2>

                  <p>Use your Sirv account for your other websites too (not just WordPress). Files hosted on Sirv can be served to any website including Magento, Drupal, Squarespace, Joomla, PrestaShop and custom built sites.</p>

                  <p>Search our <a href="https://sirv.com/help" target="_blank">Help Center</a>, for tutorials that get the best out of Sirv.</p>

                  <p>Popular articles:</p>

                  <ul>
                  <li><a href="https://sirv.com/help/resources/dynamic-imaging" target="_blank">Dynamic imaging guide</a> - for resizing, watermarking, optimizing and all other dynamic options.</li>
                  <li><a href="https://sirv.com/help/resources/responsive-imaging/" target="_blank">Responsive imaging guide</a> - for serving images to perfectly fit each users screen.</li>
                  <li><a href="https://sirv.com/help/resources/sirv-zoom/" target="_blank">Zoom guide</a> - for customizing your deep image zooms.</li>
                  <li><a href="https://sirv.com/help/resources/sirv-spin/" target="_blank">360 guide</a> - for customizing your 360 spins.</li>
                  </ul>
                </div>
              </div>

        </div>

        <div class="sirv-tab-content" id="help-feedback">
            <!-- <h2>How can we help?</h2> -->
            <!-- <p>
                Search our <a target="_blank" href="https://sirv.com/help">help section</a>, for tutorials that help you get the best out of Sirv.<br /><br />
                <a href="mailto:support@sirv.com">support@sirv.com</a>
                Popular articles:
            </p>
            <ul style="list-style-type: circle; padding-left: 2%;">
                <li><a href="https://sirv.com/help/resources/dynamic-imaging">Dynamic imaging guide</a> - for resizing, watermarking, optimizing and all other dynamic options</li>
                <li><a href="https://sirv.com/help/resources/responsive-imaging/">Responsive imaging guide</a> - for serving images to perfectly fit each users screen</li>
                <li><a href="https://sirv.com/help/resources/sirv-zoom/">Zoom guide</a> - for customizing your deep image zooms</li>
                <li><a href="https://sirv.com/help/resources/sirv-spin/">360 guide</a> - for customizing your 360 spins</li>
            </ul>
            <br /> -->
            <p><h2>Contact us</h2>
            <div class="sirv-optiontable-holder">
                <table class="optiontable form-table">
                    <tr>
                      <td>
                        <label class='required'><b>Your name:</b></label>
                        <input type="text" name="name" id="sirv-writer-name">
                      </td>
                    </tr>
                    <tr>
                      <td>
                        <label class='required'><b>Your email:</b></label>
                        <input type="text" name="contact-email" id="sirv-writer-contact-email">
                      </td>
                    </tr>
                    <!--<tr>
                        <td>
                            <label>Priority:</label>
                            <select id="sirv-priority" name="priority">
                                <option label="Low" value="Low">Low</option>
                                <option label="Normal" value="Normal" selected="selected">Normal</option>
                                <option label="High" value="High">High</option>
                                <option label="Urgent" value="Urgent">Urgent</option>
                            </select>
                        </td>
                    </tr>-->
                    <tr>
                        <td>
                            <label class='required'><b>Summary:</b></label>
                            <input type="text" name="summary" id="sirv-summary">
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <label class='required'><b>Describe your issue or share your ideas:</b></label>
                            <textarea style="width:100%;height:200px;" name="text" id="sirv-text"></textarea>
                        </td>
                    </tr>


                    <tr>
                        <td>
                            <input id="send-email-to-magictoolbox" type="button" class="button-primary test-connect" value="Send message">
                            <div class="sirv-show-result"></div>
                        </td>
                    </tr>
                </table>
            </div>

        </div>




    </form>
</div>
